/**
  * @file ${obj.name.lower()}_dev.h
  * @author generated by mrt-device tool
  * @brief values and constants for the ${obj.name} device
  * 
  */

% if "I2C" in obj.bus.upper():
#define ${obj.name.upper()}_I2C_ADDRESS ${ obj.formatHex(obj.i2c_addr, 1)}
% endif
#define ${obj.name.upper()}_REG_ADDR_SIZE ${ obj.addrSize}


/*******************************************************************************
  Register Addresses                                                                              
*******************************************************************************/

% for key,reg in obj.regs.items():
#define ${obj.prefix.upper() +"_REG_"+reg.name.upper()+"_ADDR"}                       ${reg.printAddr()}
% endfor


/*******************************************************************************
  Fields                                                                              
*******************************************************************************/

% for key,reg in obj.regs.items():
% if len(reg.fields) > 0 :
/* ${reg.name} Register Fields */
    %if reg.hasFlags:
    /* ${reg.name} -> Flags */
    %endif
    %for field in reg.fields:
    %if field.isFlag:
    #define ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper()}                       ${reg.formatHex(field.mask)}
    %endif
    %endfor
    %for field in reg.fields:
    %if not field.isFlag:
    /* ${reg.name} -> ${field.name} */
    #define ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_MASK"}        ${reg.formatHex(field.mask)}
    %for val in field.vals:
    #define ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_" + val.name.upper()}      ${reg.formatHex(val.val)}
    
    %endfor
    %endif
    %endfor
% endif
% endfor

/*******************************************************************************
  Default Values                                                                              
*******************************************************************************/

% for key,reg in obj.regs.items():
% if reg.hasDefault:
#define ${obj.prefix.upper() +"_"+reg.name.upper()+"_DEFAULT"}  ${reg.formatHex(reg.default)}
% endif
% endfor

/*******************************************************************************
  Flag Set/Clear/Check                                                                             
*******************************************************************************/

/**
  *@brief sets flags on device
  *@param dev ptr to ${obj.name} device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define ${obj.prefix.lower() +"_set_flag"}(dev, reg, mask) regdev_set_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief clears flags on device
  *@param dev ptr to ${obj.name} device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define ${obj.prefix.lower() +"_clear_flag"}(dev, reg, mask) regdev_clear_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief checks flags on device
  *@param dev ptr to ${obj.name} device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  *@return true if all flags in mask are set 
  *@return false if any flags in mask are not set
  */
#define ${obj.prefix.lower() +"_check_flag"}(dev, reg, mask) regdev_check_flags(&(dev)->mRegDev,(reg), (mask))

/*******************************************************************************
  Field Getters                                                                              
*******************************************************************************/

% for key,reg in obj.regs.items():
% if "R" in reg.perm.upper():
% for field in reg.fields:
% if not field.isFlag:
/**
 * @brief reads the ${field.name} field from the device 
 * @param dev ptr to ${obj.name} device
%for val in field.vals:
 * @return ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_" + val.name.upper()} ${val.desc}
%endfor
 */
#define ${obj.prefix.lower() +"_get_"+ reg.name.lower()+"_"+field.name.lower()}(dev) regdev_read_field(dev->mRegDev, &(dev)->${"m" + obj.camelCase(reg.name)}, ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_MASK"} )

%endif
%endfor
%endif
% endfor


/*******************************************************************************
  Field Setters                                                                              
*******************************************************************************/

% for key,reg in obj.regs.items():
% if "W" in reg.perm.upper():
%for field in reg.fields:
% if not field.isFlag:
/**
 * @brief writes the ${field.name} field from the device 
 * @param dev ptr to ${obj.name} device
%for val in field.vals:
 * @option ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_" + val.name.upper()} ${val.desc}
%endfor
 */
#define ${obj.prefix.lower() +"_set_"+ reg.name.lower()+"_"+field.name.lower()}(dev) regdev_write_field(dev->mRegDev, &(dev)->${"m" + obj.camelCase(reg.name)}, ${obj.prefix.upper() +"_"+reg.name.upper()+"_"+field.name.upper() +"_MASK"} )

%endif
%endfor
%endif
% endfor

